/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
Multimediale Systeme der Informationsverarbeitung
Institut fuer Informatik
Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @example ExampleCompare.cpp
   @class ExampleCompare
   @relates CompareFloatingPoint
   @brief Example for comparing two floats
   @ingroup g_examples
   @author MIP
*/

#include <Base/Common/CompareFloatingPoint.hh>
#include <iostream>
#include <limits>

using namespace std;
using namespace BIAS;

int main(){
  double l=1.0e-50, r=1e-49;
  cout << l<<" == "<<r<<" is "<<boolalpha << Equal(l, r) << endl;

  BIAS::Less(l, -std::numeric_limits<double>::max());

  return 0;

}
