/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @example ExampleProgressSemaphore.cpp
   @class ExampleProgressSemaphore
   @relates ProgressSemaphore,ProgressSemaphorePool
   @brief Example for ProgressSemaphore registering in ProgressSemaphorePool
   @ingroup g_examples
   @author woelk   
*/

#include <Base/Common/ProgressSemaphorePool.hh>
#include <Base/Common/ProgressSemaphore.hh>
#include <iostream>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  ProgressSemaphorePool *SP = Singleton<ProgressSemaphorePool>::GetInstance();

  SharedPtr<ProgressSemaphore>  foo= SP->Register("foo");
  SharedPtr<ProgressSemaphore> bar= SP->Register("bar");

  vector<string> allnames;

  SP->GetAllSemaphoreNames(allnames);
  for (unsigned int i=0;i<allnames.size();i++)
    cout <<"registered: "<<allnames[i]<<endl;

  foo->SetNumSteps(100);
  foo->SetCurrentStep(10);
  cout <<"foo has finished: "<<foo->GetProgress()<<endl;

  return 0;
}
