#ifndef __ProgressSemaphore_hh__
#define __ProgressSemaphore_hh__

// includes
#include <bias_config.h>
#ifdef BIAS_HAVE_PTHREADS
#include <pthread.h>
#endif
namespace BIAS {
  



  /** @class ProgressSemaphore
      @brief

      @author evers 03/2008 */
  class BIASCommon_EXPORT ProgressSemaphore
  {
  public:
    ProgressSemaphore();
    /// destructor
    ~ProgressSemaphore();

    float GetProgress(); // returns current progress state in standard intervall
    void SetNumSteps(unsigned int steps); // 
    void SetCurrentStep(unsigned int CurrentStep);
    void IncrementStep();
    void SetTerminateFlag();
    void ResetTerminateFlag();
    bool IsTerminationRequested();

    void Reset();


  protected:
#ifdef BIAS_HAVE_PTHREADS
    pthread_mutex_t Lock_;
#endif
	unsigned int NumSteps_;
    unsigned int CurrentStep_;
    bool Terminate_;
    
  }; // class ProgressSemaphore

} // namespace

#endif // __ProgressSemaphore_hh__
