/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example ExampleLogFacility.cpp
   @class ExampleLogFacility
   @relates LogFacility
   @brief Example for using the logging facility 
   @ingroup g_examples
   @author MIP   
*/

#include <stdlib.h>
// BIAS
#include <Base/Debug/LogFacility.hh>

using namespace BIAS;
using namespace std;

class MyTestClass {
public:
  MyTestClass() {
  };

};


int main(int argc, char *argv[])
{
  if (argc>1){
    int ll=atoi(argv[1]);
    cout <<"Now setting current loglevel to: "<<ll<<endl;
    LogFacility::Instance()->SetLogLevel((BIAS_LOG_LEVEL)ll);
    if (ll==5) {
      LogFacility::Instance()->SetLogLevel(BIAS_LOG_DEBUG);
      LogFacility::Instance()->SetShowCodeInfo(true);
    }
    if (ll==6){
      LogFacility::Instance()->SetLogLevel(BIAS_LOG_DEBUG);
      LogFacility::Instance()->SetAbortOnFatal(true);
    }
  }

  if (argc>2){
    cout <<"Now setting log stream tofile: "<<argv[2]<<endl;
    LogFacility::Instance()->OpenLogFile(argv[2]);
  }

  // this is the full qualified official usage of the LFwithout checking level
  LogFacility::Instance()->GetLogStream()<<"Ok, starting up LogFacility"<<endl;


  // this macros accepts arbitrary stream-concatenations, checks loglevel
  // and codeinfo
  BIASLOG(BIAS_LOG_DEBUG,"This is a debug line number:"<<2);

  // this is the short form of the above:
  BLD("This is a debug line number:"<<3);

  BLI("This is an info  line");
  BLW("This is a warning  line");
  BLF("This is a fatal error");


  return 0;
}

