/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example ExampleQuaternion.cpp
   @class ExampleQuaternion
   @relates Quaternion
   @brief Example Quaternion usage
   @ingroup g_examples
   @author MIP  
*/

#include "../Quaternion.hh"

using namespace std;
using namespace BIAS;

int main() 
{
  Quaternion<double> q;
  q.SetValueAsAxisRad(-0.97856,0.049681,-0.14840,0.00102);
//   RMatrixBase R;
//   double PhiX, PhiY, PhiZ;
//   q.GetRotationMatrix(R);
//   R.GetRotationAnglesXYZ(PhiX, PhiY, PhiZ);
//   cout << "Rotation  XYZ: " << PhiX << "," <<  PhiY << "," << PhiZ << endl;
//   R.GetRotationAnglesZYX(PhiX, PhiY, PhiZ);
//   cout << "Rotation  ZYX: " << PhiX << "," <<  PhiY << "," << PhiZ << endl;

  Quaternion<double> p;
  p.SetValueAsAxisRad(-0.97856,0.049681,-0.14840,0.00102);
  cout<<"q*p = "<<q*p<<endl;
  Matrix4x4<double> M = q.GetQuaternionMultMatrixLeft();
  cout<<"M(q)*p = "<<M*p<<endl;
  
  //  Vector3<double> vec(0.5,0.5,0),res;
  //q.MultVec(vec,res);
  //cout<<"result is:"<<res<<endl;

}
