#include "Triangle.hh"

BIAS::Triangle::Triangle(const HomgPoint2D &a,
                         const HomgPoint2D &b,
                         const HomgPoint2D &c)
: a_(a), b_(b), c_(c) {
  // nothing to do here...
}


void BIAS::Triangle::GetBarycentricCoords(const HomgPoint2D &p,
                                          double &lambdaA,
                                          double &lambdaB,
                                          double &lambdaC) {
  const double div =   (a_[0] - c_[0]) * (b_[1] - c_[1])
                     - (b_[0] - c_[0]) * (a_[1] - c_[1]);

  lambdaA = (  (b_[1] - c_[1]) * (p[0] - c_[0])
             + (c_[0] - b_[0]) * (p[1] - c_[1]))
            / div;
  lambdaB = (  (c_[1] - a_[1]) * (p[0] - c_[0])
             + (a_[0] - c_[0]) * (p[1] - c_[1]))
            / div;
  lambdaC = 1.0 - lambdaA - lambdaB;
}