#include <Base/Image/ImageBase.hh>
#include <Base/Image/ImageIO.hh>

using namespace BIAS;
using namespace std;

/**
   @example ExampleROIImage.cpp
   @class ExampleROIImage
   @relates ROI,ImageBase
   @brief Example for usage of Image ROI (Region Of Interest)
   @ingroup g_examples
   @author MIP
*/

int main(int argc, char *argv[])
{  
  if(argc<2)
  {    
    cout<<"loads image and embeds a roi mask."<<endl ; 
    return -4;
  }    

  Image<unsigned char> img, roimg;    
  if(ImageIO::Load(argv[1],img)!=0)
  {
    cout<<"file not found "<<argv[1]<<endl;
    return -8; 
  } 
  unsigned w = img.GetWidth();
  unsigned h = img.GetHeight();
  roimg.Init(w,h);  
  unsigned char** dat = roimg.GetImageDataArray();   
  for(unsigned y=0; y<h; y++)
  {
    for(unsigned x=0; x<w; x++)
    {      
      if((x>(w/4))&&(x<((w*3)/4))&&
         (y>(h/4))&&(y<((h*3)/4))
        )
        dat[y][x]= 0;
      else
        dat[y][x]= 255;

    }
  }
  img.GetROI()->SetMaskImage(roimg);
  ImageIO::Save("roimaskexample.mip",img);
  return 0;
}
