/* This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


/**
   @example ExampleMatrixConvolution.cpp
   @class ExampleMatrixConvolution
   @relates Matrix
   @brief Example for convolution of two matrices
   @ingroup g_examples
   @author woelk 01/2008 (c) www. vision-n.de 
*/ 

#include <Base/Math/Matrix.hh>
#include <iostream>

using namespace BIAS;
using namespace std;

/**
   @example ExampleMatrixConvolution.cpp
   @brief Example for convolution of two matrices
   @ingroup g_examples
   @author woelk 01/2008 (c) www. vision-n.de 
*/ 
int main(int argc, char *argv[])
{
  const int sl=3, sr=3;
  Matrix<int> left(sl,sl), right(sr,sr), res;

  for (int y=0; y<sl; y++){ 
    for (int x=0; x<sl; x++){ 
      left[y][x] = 1;
    }
  }

  for (int y=0; y<sr; y++){ 
    for (int x=0; x<sr; x++){ 
      right[y][x] = 1;
    }
  }

  Conv(left, right, res);

  cout << "convolution of "<<left<<" and "<<right<<" results in "<<res<<endl;

  return 0;
}
