/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _BIASMath_hh_
#define _BIASMath_hh_
#include "bias_config.h" 

/**
    @brief This includes all header files neccessary for compiling and 
    linking with this library.
    
    changed from BIAS to BIAS (jw, 11/05/2002)

    @author Jan Woetzel
    @status beta (11/05/2002) 
**/


// general Matrix
#include "Matrix.hh"

// general Vector
#include "Vector.hh"

// specialised Matrices:
#include "Matrix2x2.hh"
#include "Matrix3x3.hh"
#include "Matrix4x4.hh"
#include "Matrix3x4.hh"

// specialised Vectors:
#include "Vector4.hh"
#include "Vector3.hh"
#include "Vector2.hh"

// the non class member arithmetic operators
#include "Operators.hh"


#endif

