
// Jan Woetzel

#ifndef _RGBA_hh_
#define _RGBA_hh_

#include "bias_config.h" 
#include <Base/Math/Vector4.hh>


/// predefined colors
/// opaque = not transparent
#define RGBAuc_WHITE_OPAQUE BIAS::RGBAuc(255,255,255, 255)

/// semi transparent white
#define RGBAuc_WHITE_SEMI   BIAS::RGBAuc(255,255,255, 128)
/// semi transparent black
#define RGBAuc_BLACK_SEMI   BIAS::RGBAuc(0,0,0, 128)
/// semi transparent red
#define RGBAuc_RED_SEMI BIAS::RGBAuc(255, 0, 0, 128)
/// semi transparent green
#define RGBAuc_GREEN_SEMI BIAS::RGBAuc(0, 255, 0, 128)
/// semi transparent blue
#define RGBAuc_BLUE_SEMI BIAS::RGBAuc(0, 0, 255, 128)
/// semi transparent yellow 
#define RGBAuc_YELLOW_SEMI BIAS::RGBAuc(255, 255, 0, 128)
/// semi transparent 
#define RGBAuc_CYAN_SEMI BIAS::RGBAuc(0, 255, 255, 128)
/// semi transparent magenta
#define RGBAuc_MAGENTA_SEMI BIAS::RGBAuc(255, 0, 255, 128)
/// semi transparent medium grey
#define RGBAuc_GREY_SEMI BIAS::RGBAuc(128, 128, 128, 128)
/// semi transparent dark red
#define RGBAuc_DARKRED_SEMI BIAS::RGBAuc(128, 0, 0, 128)
/// semi transparent dark green
#define RGBAuc_DARKGREEN_SEMI BIAS::RGBAuc(0, 128, 0, 128)
/// semi transparent darkblue
#define RGBAuc_DARKBLUE_SEMI BIAS::RGBAuc(0, 0, 128, 128)



namespace BIAS {
	/** @class RGBAuc 
	@ingroup g_math
	@brief class RGBAuc is asynonym for a Vector4 of corerct type
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<unsigned char> RGBAuc;

	/** @class RGBAf 
	@ingroup g_math
	@brief class RGBAf is asynonym for a Vector4 of correct type
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<float> RGBAf;

	/** @class RGBAd 
	@ingroup g_math
	@brief class RGBAd is asynonym for a Vector4 of correct type 
	@author Jan Woetzel	**/
	typedef BIAS::Vector4<double> RGBAd;

} // namespace BIAS
#endif

