# - Find Boost library installation 
# See www.boost.org) 
#  
#  Boost_FOUND
#  Boost_INCLUDE_DIR
#  Boost_graph_LIBRARY
#
# OPTION: 
# Boost_graph_REQUIRED : set it to true before calling this macro 
# if you need the compiled graph read library (Patrick, jw)
#
#
# DO NOT SPEND TIME ON IMPROVEMENTS !!!
# Brad and Andrew are actually developing 
# a general purpose FindBoost.cmake
# which will be included in CMake, soon. (JW)
#
# There is no need to add libs on Windows because boost 
# solves lib dependencies through pragmas in header files.
# (except at least graphviv...)
#
# AUTHOR
# Jan Woetzel <http://www.mip.informatik.uni-kiel.de/~jw> (07/2006)
# based on previous work from Andrew Maclean

#=====================================================================

SET(BOOST_DBG_LIBRARIES "")
SET(BOOST_RLS_LIBRARIES "")
SET(BOOST_LINK_LIBRARIES "")

FIND_PATH(Boost_ROOT_DIR
  NAMES boost/multi_array.hpp
  PATHS
  /usr/include
  "${Boost_DIR}" 
  "$ENV{Boost_DIR}" 
  "$ENV{EXTERN_LIBS_DIR}"
  "C:/boost/"
  "/opt/net/gcc41/boost/"
  #"/opt/net/gcc41/boost_cvs/boost"
  PATH_SUFFIXES
  "include"
  "include/boost-1_33_1"
  "include/boost-1_34_1"
  "include/boost-1_35_1"
  "boost_1_39_0"  
  DOC "Boost root dir containing boost/multi_array.hpp"
  #NO_SYSTEM_ENVIRONMENT_PATH
  #NO_CMAKE_SYSTEM_PATH
  )

#MESSAGE("----------------------------------------- DBG Boost_ROOT_DIR=${Boost_ROOT_DIR}")

############################
# find boost graph library RELEASE
############################
FIND_LIBRARY(Boost_graph_LIBRARY
  NAMES
  boost_graph-mt
  boost_graph-vc-mt-1_35
  #boost_graph-vc-gd-1_35 
  boost_graph-gcc41-1_35
  #libboost_graph-gcc41-1_35.so.1.35.0 
  #boost_graph-gcc41-d-1_35
  libboost_graph-vc80-mt-1_39
  PATHS 
  ${PATH}
  ${Boost_ROOT_DIR}
  PATH_SUFFIXES
  "bin.v2/libs/graph/build/msvc/release/threading-multi"
  "bin.v2/libs/graph/build/gcc-4.1.0/release"
  "graph/build/msvc-8.0/release/link-static/threading-multi"
  "lib" 
  #/opt/net/gcc41/boost_cvs/boost/bin.v2/libs/graph/build/gcc-4.1.0/release
  )
  #MESSAGE("DBG Boost_graph_LIBRARY=${Boost_graph_LIBRARY}")
  IF  (Boost_graph_LIBRARY)
    SET(BOOST_RLS_LIBRARIES ${BOOST_RLS_LIBRARIES} ${Boost_graph_LIBRARY} )
    GET_FILENAME_COMPONENT(TMP ${Boost_graph_LIBRARY} PATH )
    SET(Boost_LINK_DIRECTORIES ${Boost_LINK_DIRECTORIES} ${TMP} )   
  ENDIF (Boost_graph_LIBRARY)
########################## 

##########################
# find system library RELEASE
##########################
FIND_LIBRARY(BOOST_SYSTEM_LIBRARY 
  NAMES 
	libboost_system-vc80-mt-1_39
	boost_system
  PATHS  
      ${Boost_ROOT_DIR} 
  PATH_SUFFIXES 
      "lib" 
  )
#MESSAGE("DBG BOOST_SYSTEM_LIBRARY=${BOOST_SYSTEM_LIBRARY}")
IF (BOOST_SYSTEM_LIBRARY)
SET(BOOST_RLS_LIBRARIES ${BOOST_RLS_LIBRARIES} ${BOOST_SYSTEM_LIBRARY} )
GET_FILENAME_COMPONENT(TMP ${BOOST_SYSTEM_LIBRARY} PATH )
SET(Boost_LINK_DIRECTORIES ${Boost_LINK_DIRECTORIES} ${TMP} ) 
ENDIF(BOOST_SYSTEM_LIBRARY)
############################

##########################
# find filesystem library RELEASE
##########################
FIND_LIBRARY(BOOST_FILESYSTEM_LIBRARY
  NAMES
      libboost_filesystem-vc80-mt-1_39.lib
	boost_filesystem
  PATHS 
      ${Boost_ROOT_DIR}
  PATH_SUFFIXES
      "lib"
  )
IF (BOOST_FILESYSTEM_LIBRARY)
#MESSAGE("DBG BOOST_FILESYSTEM_LIBRARY=${BOOST_FILESYSTEM_LIBRARY}")
SET(BOOST_RLS_LIBRARIES ${BOOST_RLS_LIBRARIES} ${BOOST_FILESYSTEM_LIBRARY})
GET_FILENAME_COMPONENT(TMP ${BOOST_FILESYSTEM_LIBRARY} PATH )
SET(Boost_LINK_DIRECTORIES ${Boost_LINK_DIRECTORIES} ${TMP} ) 
ENDIF(BOOST_FILESYSTEM_LIBRARY)
############################

############################
# find boost graph library DEBUG
############################
FIND_LIBRARY(Boost_graph_LIBRARY_DBG
  NAMES
  libboost_graph-vc80-mt-gd-1_39
  PATHS 
  ${Boost_ROOT_DIR}
  PATH_SUFFIXES
  "lib" 
  )
  IF  (Boost_graph_LIBRARY_DBG)
    SET(BOOST_DBG_LIBRARIES ${BOOST_DBG_LIBRARIES} ${Boost_graph_LIBRARY_DBG} )   
  ENDIF (Boost_graph_LIBRARY_DBG)
##########################

##########################
# find system library DEBUG
##########################
FIND_LIBRARY(BOOST_SYSTEM_LIBRARY_DBG 
  NAMES 
	libboost_system-vc80-mt-gd-1_39
  PATHS  
      ${Boost_ROOT_DIR} 
  PATH_SUFFIXES 
      "lib" 
  )
IF (BOOST_SYSTEM_LIBRARY_DBG)
SET(BOOST_DBG_LIBRARIES ${BOOST_DBG_LIBRARIES} ${BOOST_SYSTEM_LIBRARY_DBG} )
ENDIF(BOOST_SYSTEM_LIBRARY_DBG)
############################

##########################
# find filesystem library DEBUG
##########################
FIND_LIBRARY(BOOST_FILESYSTEM_LIBRARY_DBG
  NAMES
      libboost_filesystem-vc80-mt-gd-1_39.lib
  PATHS 
      ${Boost_ROOT_DIR}
  PATH_SUFFIXES
      "lib"
  )
IF (BOOST_FILESYSTEM_LIBRARY_DBG)
SET(BOOST_DBG_LIBRARIES ${BOOST_DBG_LIBRARIES} ${BOOST_FILESYSTEM_LIBRARY_DBG})
ENDIF(BOOST_FILESYSTEM_LIBRARY_DBG)
############################

IF(WIN32)
FOREACH(TMP ${BOOST_RLS_LIBRARIES}) 
SET(BOOST_LINK_LIBRARIES ${BOOST_LINK_LIBRARIES} optimized ${TMP} )
ENDFOREACH(TMP ${BOOST_RLS_LIBRARIES}) 

FOREACH(TMP ${BOOST_DBG_LIBRARIES}) 
SET(BOOST_LINK_LIBRARIES ${BOOST_LINK_LIBRARIES} debug ${TMP} )
ENDFOREACH(TMP ${BOOST_DBG_LIBRARIES}) 
ELSE(WIN32)
SET(BOOST_LINK_LIBRARIES ${BOOST_RLS_LIBRARIES} ${BOOST_DBG_LIBRARIES} )
ENDIF(WIN32)

SET(Boost_INCLUDE_DIR ${Boost_ROOT_DIR})

IF    (Boost_INCLUDE_DIR)
  SET(Boost_FOUND 1)
ENDIF (Boost_INCLUDE_DIR)

MARK_AS_ADVANCED(
  Boost_INCLUDE_DIR 
  Boost_LINK_DIRECTORIES
  Boost_graph_LIBRARY 
  BOOST_FILESYSTEM_LIBRARY
  BOOST_SYSTEM_LIBRARY
  Boost_graph_LIBRARY_DBG 
  BOOST_FILESYSTEM_LIBRARY_DBG
  BOOST_SYSTEM_LIBRARY_DBG
  BOOST_LINK_LIBRARIES
)

#MESSAGE("DBG BOOST_LINK_DIRECTORIES=${Boost_LINK_DIRECTORIES}")
#MESSAGE("DBG BOOST_RLS_LIBRARIES=${BOOST_RLS_LIBRARIES}")
#MESSAGE("DBG BOOST_DBG_LIBRARIES=${BOOST_DBG_LIBRARIES}")
#=====================================================================
IF(NOT Boost_FOUND)
  # make FIND_PACKAGE friendly
  IF(NOT Boost_FIND_QUIETLY)
    IF(Boost_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR
        "Boost required, please specify it's location.")
    ELSE(Boost_FIND_REQUIRED)
      MESSAGE(STATUS "ERROR: Boost was not found.")
    ENDIF(Boost_FIND_REQUIRED)
  ENDIF(NOT Boost_FIND_QUIETLY)
ENDIF(NOT Boost_FOUND)


