# Search for UMF package for sparse matrix operations
# UMFPACK_FOUND
# UMFPACK_INCLUDE_DIR
# UMFPACK_LIBRARIES

IF(WIN32)

  # TODO Implement for WIN32!

  SET(UMFPACK_FOUND FALSE)
  MSG_FATAL("UMF package is not yet available for WIN32!")

ELSE(WIN32)	    

  FIND_PATH(UMFPACK_INCLUDE_DIR "suitesparse/umfpack.h" "/usr/include/")
  
  IF(UMFPACK_INCLUDE_DIR)

    SET(UMFPACK_INCLUDE_DIR "${UMFPACK_INCLUDE_DIR}/suitesparse/")
    #MESSAGE(${UMFPACK_INCLUDE_DIR})
    find_library(UMFPACK_LIB 
      umfpack
      "/usr/lib/" 
      "/usr/lib64/"
    )
    find_library(AMD_LIB 
      amd
      "/use/lib/"
      "/usr/lib64/"
    )

    IF(UMFPACK_LIB AND AMD_LIB)

      SET(UMFPACK_LIBRARIES ${UMFPACK_LIB} ${AMD_LIB})
      SET(UMFPACK_FOUND TRUE)

    ELSE(UMFPACK_LIB AND AMD_LIB)

      SET(UMFPACK_FOUND FALSE)

    ENDIF(UMFPACK_LIB AND AMD_LIB)

  ELSE(UMFPACK_INCLUDE_DIR)

    SET(UMFPACK_FOUND FALSE)

  ENDIF(UMFPACK_INCLUDE_DIR)

ENDIF(WIN32)
 
 

 
