/* This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/
#include <Filter/Tests/TestFilterBase.hh>
#include <Filter/Binomial.hh>

using namespace BIAS;

/**
   @file TestFilterBinomial   
   @brief Test the binomial filter
   @ingroup g_tests
   @author woelk 06/2008 (c) www.vision-n.de 
*/

template <class T>
void Test()
{
  Image<T> zero3(10, 10, 3), one3(10, 10, 3);
  Image<T> zero(10, 10, 1), one(10, 10, 1);
  zero.FillImageWithConstValue((T)0.);
  one.FillImageWithConstValue((T)1.);
  zero3.FillImageWithConstValue((T)0.);
  one3.FillImageWithConstValue((T)1.);

  TestFilterBase<Binomial, T, T> tfb;
  tfb.AddTestData(FilterTestPair<T, T>(zero, zero));
  tfb.AddTestData(FilterTestPair<T, T>(one, one));
  tfb.AddTestData(FilterTestPair<T, T>(zero3, zero3));
  tfb.AddTestData(FilterTestPair<T, T>(one3, one3));
  

  if (!tfb.Test()) { BIASABORT; }
}


int main(int argc, char *argv[])
{
  Test<unsigned char>();
  //Test<float>();
  return 0;
}
