#include <GLviewer/ContextPBuffer.hh>

#include <OpenGLFramework/Base/glfException.hh>

using namespace std;
using namespace BIAS;
using namespace BIAS;


int ContextPBuffer::
Init(unsigned int width, unsigned int height, 
     unsigned int RBits, unsigned int GBits, unsigned int BBits,
     unsigned int ABits, unsigned int DepthBits, unsigned int StencilBits)
{
  glfRenderingContextConfig cfg;
  cfg.width         = width;                  
  cfg.height        = height;
  cfg.doubleBuffer  = 0;
  cfg.redSize       = RBits;
  cfg.greenSize     = GBits;
  cfg.blueSize      = BBits;
  cfg.alphaSize     = ABits;
  cfg.depthSize     = DepthBits;
  cfg.stencilSize   = StencilBits;

  try {
    glfPBuffer::Init(cfg);
  } catch (glfException& e) {
    std::cout << "Error: " << e.GetMessageString() << std::endl;
    return -1;
  } 
  return 0;
}


int ContextPBuffer::
Render() {
  MakeCurrent();
  int res =RenderContextBase::Render();
  glFinish(); 
  return res;
}


int ContextPBuffer::
GetImage(BIAS::Image<unsigned char>& Image) 
{
  MakeCurrent();
  RenderContextBase::GetImage(Image);
  glFinish();
  return 0;
}

int ContextPBuffer::
GetDepthMap(BIAS::Image<float>& Image, const float invalid)
{
  MakeCurrent();
  int res = RenderContextBase::GetDepthMap(Image, invalid);
  glFinish();
  return res;
}

int ContextPBuffer::
GetMetricZMap(BIAS::Image<float>& Image, const float invalid)
{
  MakeCurrent();
  int res = RenderContextBase::GetMetricZMap(Image, invalid);
  glFinish();
  return res;
}
