#ifndef __CONTEXT_PBUFFER_HH__
#define __CONTEXT_PBUFFER_HH__

#include <OpenGLFramework/RenderingContext/glfPBuffer.hh>
#include <GLviewer/RenderContextBase.hh>

namespace BIAS {
  /** \class ContextPBuffer 
      \brief Wrapping class implementation for PBuffer class.
      \author bartczak
      \ingroup g_glviewer
  */
  class BIASGLviewer_EXPORT ContextPBuffer 
    : public RenderContextBase, public BIAS::glfPBuffer
  {
  public:
    virtual ~ContextPBuffer() { Destroy(); }//Release(); }
    
    int Init(unsigned int width, unsigned int height,  
             unsigned int RBits=8, unsigned int GBits=8, unsigned int BBits=8,
             unsigned int ABits=0, unsigned int DepthBits=24, unsigned int StencilBits=0);

    int Render();
    void* Draw(void*) { Render(); return NULL; };

    int GetImage(BIAS::Image<unsigned char>& Image);

    int GetDepthMap(BIAS::Image<float>& Image, const float invalid=0.0);
    int GetMetricZMap(BIAS::Image<float>& Image, const float invalid=0.0);

    virtual void Redisplay() {Render();}

    virtual void MakeGLContextCurrent()
    {BIAS::glfPBuffer::MakeCurrent(); }
    
    virtual void SetTimer(unsigned int /*interval*/) {
      BIASERR("No Timer for PBuffer");}
    virtual void DeactivateTimer() {
      BIASERR("No Timer for PBuffer");}

  };
}//end of namespace

#endif
