#ifndef __TrackballTransControl_HH__
#define __TrackballTransControl_HH__

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need BIAS with USE_OpenGL Please recompile BIAS.
#endif // BUILD_GLviewer

#include <GLviewer/Controller/TrackballBase.hh>
#include <GLviewer/TransformNode.hh>

namespace BIAS
{

  /** @class TrackballTransControl
      @author grauel
      @ingroup g_glviewer
      @brief class for editing scenegraph transform nodes in trackball mode
  */  
  class BIASGLviewer_EXPORT TrackballTransControl : public TrackballBase
  {
      
    public:

    TrackballTransControl();
    virtual ~TrackballTransControl();
            
    bool RightMouseMoved(int x1, int x2, int y1, int y2);
    void MoveInViewingDirection(double stepSize);

    /**
    * Rotates the tranformed object
    */
    bool LeftMouseMoved(int x1, int x2, int y1, int y2);
    void Rotate(BIAS::Vector3<double> axis, double angleRAD);
    
    /** should set point of interesr but is not supported by */
    bool LeftMouseDoubleClicked(int x, int y);

    /** rotate around viewing direction */
    bool LeftAndRightMouseMoved(int x1, int x2, int y1, int y2);
    
    /**
       Handles Mouse Wheel events and zooms in or out
    */
    bool MouseWheelUsed(double stepsize);

    /**
    * Moves the transform node left/right/up/down 
    */    
    bool MiddleMouseMoved(int x1, int x2, int y1, int y2);

    void RotateAroundViewingDirection(double rotationAngleRAD);
 
    void SetTransformNode(TransformNode* trn)
    {
      TransNode_ = trn;
    }
  protected:

   // void Scale(BIAS::Vector3<double>);
    void Translate_(BIAS::Vector3<double>& v);
    void Rotate_(BIAS::Vector3<double>& axis,double rotationagle);

    TransformNode* TransNode_;
  };
}//end of namespace

#endif
