#ifndef OUTPUT_UNDERWATER_HH_
#define OUTPUT_UNDERWATER_HH_

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need BIAS with USE_OpenGL Please recompile BIAS.
#endif // BUILD_GLviewer

#include <Gui/biasgl.h>
#include <Base/Debug/Debug.hh>

#include <OpenGLFramework/Base/glfRenderTarget.hh>
#include <GLviewer/OutputAttachments/GLProjectionOutputAttachment.hh>

namespace BIAS {

  /**
   * @brief exemplary output attachment, creating a underwater effect
   * @ingroup g_glviewer
   * @author fkellner
   */
  class BIASGLviewer_EXPORT OutputUnderwater : public GLProjectionOutputAttachment {
    public:
      // standards
      OutputUnderwater(BIAS::glfRenderTarget *out);
      ~OutputUnderwater();

      // pass zNear and zFar
      void UpdateParams(double zNear,double zFar,std::vector<int> &waterQuality);

    protected:
      /// creates strings with shader code and calls InitShader(vertex, fragment) from superclass
      int InitShader_();
      /// standard draw from superclass does not suffice to get zNear and zFar,
      /// so we need to implement this here
      int Draw_();

      float zNear_,zFar_,waterQualityR_, waterQualityG_, waterQualityB_;
      float waterColorR_, waterColorG_, waterColorB_;
      float alphaR_, alphaG_, alphaB_;
  };

}
#endif

