#ifndef OUTPUT_WOW_DISPLAY_HH_
#define OUTPUT_WOW_DISPLAY_HH_

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need BIAS with USE_OpenGL Please recompile BIAS.
#endif // BUILD_GLviewer

#include <Gui/biasgl.h>
#include <Base/Debug/Debug.hh>

#include <OpenGLFramework/Base/glfRenderTarget.hh>

#include <GLviewer/OutputAttachments/GLProjectionOutputAttachment.hh>
namespace BIAS {

  /**
   * @brief exemplary output attachment to create 2D+Depth output for Wow Displays
   * @ingroup g_glviewer
   * @author fkellner
   */
  class BIASGLviewer_EXPORT OutputWowDisplay : public GLProjectionOutputAttachment {
    public:
      // standards 
      OutputWowDisplay(BIAS::glfRenderTarget *out, int factor=0x40, int offset=0x80);
      
      virtual ~OutputWowDisplay();
    protected:
      /// creates strings with shader code and calls InitShader(vertex, fragment) from superclass 
      int InitShader_();
      /// standard draw from superclass does not suffice to set the header information for wow display,
      /// so we need to implement this here
      int Draw_();
      
    private:
      int wowFactor_, wowOffset_;
  };

}
#endif
    
