/*
 * OutputWowDisplay2.cpp
 *
 *  Created on: Mar 18, 2009
 *      Author: africk
 */

#include "OutputWowDisplay2.hh"

using namespace std;
using namespace BIAS;

OutputWowDisplay2::OutputWowDisplay2(BIAS::glfRenderTarget *out) :
  GLProjectionOutputAttachment(out)
{
  InitShader_();
}

OutputWowDisplay2::~OutputWowDisplay2()
{
  // TODO Auto-generated destructor stub
}

int
OutputWowDisplay2::InitShader_()
{

  string vertexCode =
      "void main()\r\n"
      "{\r\n"
      "  gl_TexCoord[0] = gl_MultiTexCoord0;\r\n"
      "  gl_Position = ftransform();\r\n"
      "}\r\n";
//  string vertexCode = ""
//    "varying float disparity;"
//    "void main () {\n"
//    "  gl_TexCoord[0] = gl_MultiTexCoord0;"
//    "vec4 v = gl_Vertex;"
//    ""
//    ""
//    "vec4 pos =  gl_ModelViewProjectionMatrix * v;"
//    "v.x= v.x+1;"
//    "gl_FrontColor = gl_Color;\n"
//    ""
//    ""
//    "vec4 pos_t = gl_ModelViewProjectionMatrix * v;"
//    ""
//    //"disparity = abs(pos[0]/pos[3] - pos_t[0]/pos_t[3]);"
//    "disparity = 0.5;"
//    ""
//    "gl_Position = pos;"
//    "}\n";
  string fragmentCode = "uniform sampler2D tex;"
    "uniform sampler2D dep;"
    "varying float disparity;"
    "uniform float w;"
    "uniform float h;"
    "void main() {"
    "vec2 pos = gl_TexCoord[0].st;"
    ""
    "vec3 color = vec3(0.0,0.0,0.0);"
    ""
  //  "if (mod(pos[1]*h,2.0) >= 0.5) {"
    "if (pos[0] < 0.5) {"
    "color = texture2D(tex,pos);"
    "} else {"
    "color = vec3(disparity,disparity,disparity);"
    "}"
  //  "}"
    "gl_FragColor.rgb = color;"
    "}";

  int res = 0;
  try
    {

      res = GLProjectionOutputAttachment::InitShader(vertexCode, fragmentCode);
    }
  catch (glfException& e)
    {
      std::cout << "Error: " << e.GetMessageString() << std::endl;
        BIASABORT;
    }
  return res;
}

int
OutputWowDisplay2::Draw_()
{

  int wow_content = 0x02;
  int wow_use_factor = 0x80; // 0x00 for default
  int wow_use_offset = 0x40; // 0x00 for default
  unsigned char header[] =
    { 0xF1, wow_content, 50, 0, wow_use_factor + wow_use_offset, 0x00, 0x00,
        0x00, 0x00, 0x00 };
  // Calc the CRC32
    {
      unsigned long _register = 0;
      for (int i = 0; i < 10; ++i)
        {
          unsigned char mask = 0x80;
          unsigned char byte = header[i];
          for (int j = 0; j < 8; ++j)
            {
              bool topBit = (_register & 0x80000000) != 0;
              _register <<= 1;
              _register ^= ((byte & mask) != 0 ? 0x1 : 0x0);
              if (topBit)
                {
                  _register ^= 0x04c11db7;
                }
              mask >>= 1;
            }
        }
      unsigned char *p = (unsigned char*) &_register;
      for (size_t i = 0; i < 4; ++i)
        {
          header[i + 6] = p[3 - i];
        }
    }

  int fullheader[256];
    {
      for (int x = 0; x < 256; ++x)
        {
          fullheader[x] = 0;
        }
      for (int x = 0; x <= 9; ++x)
        {
          for (int y = 7; y >= 0; --y)
            {
              int i = 2 * (7 - y) + 16 * x;
              fullheader[i] = (((1 << (y)) & (header[x])) << (7 - (y)));
            }
        }
    }

  shaderProg_.SetUniform("header", 256, fullheader);

  return GLProjectionOutputAttachment::StandardDraw_();
}
