#ifndef _CovEuler2Quaternion_hh_
#define _CovEuler2Quaternion_hh_

#include <MathAlgo/UnscentedTransform.hh>
#include <Base/Geometry/PoseParametrizationCovariance.hh>

namespace BIAS {

#define D_C3DT2D_COV 0x00000100

  /** @class CovEuler2Quaternion
      @brief Conversion of a rotation covariance in Euler-angles representation
      to a covariance in Quaternion representation using the unscented transform.
      @author streckel 07/2006 */
 
class BIASGeometry_EXPORT CovEuler2Quaternion : public UnscentedTransform
{
public:
  CovEuler2Quaternion() : UnscentedTransform() {};

  virtual ~CovEuler2Quaternion() {};

  BIAS::PoseParametrizationCovariance
    CTransform(const BIAS::Matrix<double>& cov_pose,
              const BIAS::Vector<double>& pose);

protected:
  virtual int Transform_(const BIAS::Vector<double>& src,
                         BIAS::Vector<double>& dst) const;
};

} // namespace

#endif // _CovEuler2Quaternion_hh_
