/* This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Vision N GmbH
   Schauenburgerstr. 116
   24118 Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

#include <Gui/ImageCanvasGLBase.hh>
#include <wx/wx.h>


using namespace BIAS;
using namespace std;


// --------------------------------------------------------
class ExampleImageCanvasGLBaseApp : public wxApp {
  virtual bool OnInit(); 
}; // end of ExampleImageCanvasGLBaseApp -----------------------


enum _ExampleImageCanvasGLBaseMyFrameIDs_ {
	ID_ABOUT=wxID_ABOUT,
	ID_QUIT,
	ID_LOADIMAGE,
  ID_MODECHANGE
};


// --------------------------------------------------------

class MyFrame: public wxFrame {
public:
  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);
  void OnQuit(wxCommandEvent& event);
  void OnAbout(wxCommandEvent& event);
  void OnModeChange(wxCommandEvent& event);
  void OnLoadImage(wxCommandEvent& );

  /** laod images and update content
      on Linux this has to be called after initialzation. JW */
  void LoadImages();
  

  // data member ---
  BIAS::ImageCanvasGLBase * p_canvas1;
  BIAS::ImageCanvasGLBase * p_canvas2;


  DECLARE_EVENT_TABLE()
}; // end of MyFrame --------------------------------------

