/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
Multimediale Systeme der Informationsverarbeitung
Institut fuer Informatik
Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @example TestGuiCV.cpp
   @class TestGuiCV
   @relates GuiCV  
   @brief Example for using OpenCV window 
   @ingroup g_examples
   @author MIP
*/
#include <iostream>
#ifndef WIN32
#  include <unistd.h>
#endif
#include <string>
#include <sstream>
#include <iomanip>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>
#include <Gui/GuiCV.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  ostringstream name;
  Image<unsigned char> image, image2;
  PyramidImage<unsigned char> pim;

  GuiCV win("TestTitle"), win2, win3;

  win2.SetTitle("win2");

  // no debugging
  //      win.SetDebugLevel(D_SIGNAL|D_DESTRUCT|D_MAIN);
  //      win2.SetDebugLevel(D_SIGNAL|D_DESTRUCT|D_MAIN);
  //      win.SetDebugLevel(D_DESTRUCT);
  //      win2.SetDebugLevel(D_DESTRUCT);
  //      win3.SetDebugLevel(D_DESTRUCT);
  //win.SetDebugLevel(D_DESTRUCT);
  win.SetDebugLevel(0);
  //win3.SetDebugLevel(D_KEY);
  //win2.SetDebugLevel(D_KEY);

  if (argc < 2 ) {
    image.Init(512, 255, 1);
    unsigned char **ida=image.GetImageDataArray();
    for (unsigned int y=0; y<image.GetHeight(); y++){
      for (unsigned int x=0; x<image.GetWidth(); x++){
        ida[y][x]=(unsigned char)x;
      }
    }
    cout <<"Initialized image"<<endl;
  } else {
    // load image
    if (ImageIO::Load( argv[1],image) < 0){
      //	if (image.Read(argv[1]) < 0){
      cerr << "error loading image\n";
      exit (-1);
    }
  }

  win3.SetTitle("now showing ordinary image");
  win3.ShowImage(image);

  bool Pressed;
  int Button, Xpos, Ypos;
  win3.WaitForMouseButtonEvent(Pressed, Button, Xpos, Ypos);

  pim.Init(image, 4);

  win3.SetTitle("now showing pyramid image");
  win3.ShowImage(pim);
  win3.WaitForKeyEvent();

  return 0;
#ifdef   WIN32
  Sleep(3000);
#else
  sleep(3);
#endif


  cout << win3.CheckForKeyEvent() << endl;

  win3.DestroyWindow();

  win2.SetTitle("WaitForKeyEvent()");
  win2.ShowImage(image);
  // cout << win2.WaitForKeyEvent() << endl;

  return 0;

  image2=image;
  win3.ShowImage(image2);

  win2.DestroyWindow();
  win3.DestroyWindow();

  //return 0;
  // short pnm movie
  for (int i=0; i< 86; i++){
    name.str(""); // reset ostringstream

    //	name << "/data/Orig/Parken/Laengs3/image00" 
    name << "/tmp/image00"

      << setfill('0') << setw(2) << i << ".pnm";
    //cout << name.str().c_str() << endl;
    if (ImageIO::ImportImage( name.str(),image) < 0){
      cerr << "error loading image\n";
      exit (-1);
    }

    // pixel access (slow!!!)
    for (int j=0; j<50; j++){
      image.GetImageDataArray()[100][100+j]=255;
      image.GetImageDataArray()[100][100*image.GetChannelCount()+j]=0;
      image.GetImageDataArray()[100][100*image.GetChannelCount()+j]=0;
    }
    //cout << i << "\t1\twin ShowImage\n";
    //image.IP_ToGrey();
    //cout << i << "\t2\twin ShowImage\n";
    win.ShowImage(image);
    //cout << i << "\t3\twin ShowImage\n";
    //usleep(500000);
  }

  win.DestroyWindow();
  //cout << "win DestroyWindow\n";

  image.Release();

  //return 0;

#ifdef   WIN32
  Sleep(1000);
#else
  sleep(1);
#endif
  image.Init(360, 288, 3);
  image.FillImageWithConstValue((unsigned char)0);

  //    win.CreateWindow(image);

  for (int i=0; i<256; i++){
    image.FillImageWithConstValue((unsigned char)i);
    // 	cout << i << endl;
    win.ShowImage(image);
    //usleep(50000);
  }

  win.DestroyWindow();

  return 0;
}

