/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example TestGuiEnhanced.cpp
   @class TestGuiEnhanced
   @relates GuiGTK, GuiEnhanced
   @deprecated
   @brief Example for using GTK Enhanced window
   @ingroup g_examples
   @author MIP
*/

#include <Base/Image/Image.hh>
#include <Base/ImageUtils/ImageDraw.hh>
#include <Gui/GuiGTK.hh>
#include <Gui/GuiEnhanced.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  Image<unsigned char> image;
  GuiEnhanced guie;
  int tl[2], br[2];
  guie.AddDebugLevel(D_GUI_MOUSE_BUTTON);
//   if (argc < 2 ) {
//     cerr << argv[0] <<" <filename>"<<endl;
//     exit(1);
//   }

//   // load image
//   if (image.ImportImage(argv[1]) < 0){
//     //	if (image.Read(argv[1]) < 0){
//     cerr << "error loading image\n";
//     exit (-1);
//   }
  image.Init(512, 255, 1);
  unsigned char **ida=image.GetImageDataArray();
  for (unsigned int y=0; y<image.GetHeight(); y++){
    for (unsigned int x=0; x<image.GetWidth(); x++){
      ida[y][x]=(unsigned char)x;
    }
  }

  ImageDraw<unsigned char>::RectangleCenterGrey(image,
                                          image.GetWidth()/2,
                                          image.GetHeight()/2,
                                          5,
                                          (unsigned char)255);
  ImageDraw<unsigned char>::RectangleCenterGrey(image,
                                          image.GetWidth()/2,
                                          image.GetHeight()/2,
                                          7,
                                          (unsigned char)0);
  guie.ShowImage(image);

  //
  // Test for SelectRectangle
  //
  cout << "\nSelect a rectangle with mouse, button 1 twice to select, "
       <<"any other button to cancel: " << endl;

  if (guie.SelectRectangle(tl, br) != 0){
    BIASERR("error selecting rectangle");
  }

  cout << "You selected rectangle between (" << tl[0] << ", " << tl[1]
       <<") and (" << br[0] << ", " << br[1] << ")" << endl;
  cout << "Width  of selected rectangle: " << br[0] - tl [0] << endl;
  cout << "Height of selected rectangle: " << br[1] - tl [1] << endl;
  cout << endl;


  //
  // Test for SelectQuadrate
  //
  cout << "\nSelect a quadrate with mouse, button 1 twice to select, any other button to cancel: " << endl;

  if (guie.SelectQuadrate(tl, br) != 0){
    BIASERR("error selecting quadrate");
  }

  cout << "You selected quadrate between (" << tl[0] << ", " << tl[1]
       <<") and (" << br[0] << ", " << br[1] << ")" << endl;
  cout << "Width  of selected quadrate: " << br[0] - tl [0] << endl;
  cout << "Height of selected quadrate: " << br[1] - tl [1] << endl;
  cout << endl;

  guie.DrawRectangle((unsigned int*)tl, (unsigned int*)br);


  //
  // Test for SelectPoint
  //
  cout << "\nselect a point with mouse button 1" << endl;
  guie.SelectPoint(tl);
  cout << "you selected point: ("<< tl[0] << ", " << tl[1] <<")" << endl;

  guie.DestroyWindow();

  return 0;
}
