/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example TestMouse.cpp
   @class TestMouse
   @relates GuiGTK, GuiEnhanced
   @deprecated This is an old example and should be removed or fixed!
   @brief Example for using mouse with GTK, old not working!
   @ingroup g_examples
   @author MIP
*/

#include <Base/Image/Image.hh>
#include <Gui/GuiGTK.hh>
#include <Gui/GuiEnhanced.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  char key;
  bool pressed, keyevent;
  int button, x, y;
  ostringstream name;
  Image<unsigned char> image, image2;
  Gui win("TestTitle");
  if (argc < 2 ) {
    cerr << argv[0] <<" <filename>"<<endl;
    exit(1);
  }

  // load image
  if (image.ImportImage(argv[1]) < 0){
    //	if (image.Read(argv[1]) < 0){
    cerr << "error loading image\n";
    exit (-1);
  }

  GuiEnhanced wine;
  wine.ShowImage(image);
  wine.WaitForEvent(keyevent, key, pressed, button, x, y);
  if (keyevent)
    cerr << "you pressed key " << key << endl;
  else
    if (pressed)
      cerr << "you pressed mouse button " << button << " at " << x 
	   << " " << y << endl;
    else
      cerr << "you released mouse button " << button << " at " << x 
	   << " " << y << endl;

  unsigned int point[2];
  wine.SelectPoint(point);
  cerr << "selected point (" << point[0] << ", " << point[1] << ")" << endl;
  wine.DestroyWindow();

  win.ShowImage(image);
  
  
  win.WaitForMouseButtonEvent(pressed, button, x, y);
  if (pressed){
    cerr <<"mouse button " << button << " pressed at (" << x <<", " 
	 << y <<")" << endl;
  } else {
    cerr <<"mouse button " << button << " released at (" << x <<", " 
     << y <<")" << endl;
  }
  
  win.WaitForMouseButtonEvent(pressed, button, x, y);
  if (pressed){
    cerr <<"mouse button " << button << " pressed at (" << x <<", " 
	 << y <<")" << endl;
  } else {
    cerr <<"mouse button " << button << " released at (" << x <<", " 
     << y <<")" << endl;
  }
  win.DestroyWindow();

  GuiEnhanced wine2;
  wine2.ShowImage(image);
  pressed = false;
  button = -1;
  while (button != 1 || pressed != true)
    wine2.WaitForMouseButtonEvent(pressed, button, x, y);
  wine2.GetZoomImage(x, y, 8, 15, image2);
  
  win.ShowImage(image2);
  pressed = false;
  button = -1;
  while (button != 1 || pressed != true)
    win.WaitForMouseButtonEvent(pressed, button, x, y);
  

  return 0;
}
