/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C) 2003-2009    (see file CONTACT for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __FILTER_DIALOG_PREVIEW_WINDOW_HH
#define __FILTER_DIALOG_PREVIEW_WINDOW_HH

#include <Base/Image/Image.hh>

#include <Base/Common/BIASpragmaStart.hh>
#include <wx/frame.h>
#include <wx/sizer.h>
#include <wx/string.h>
#include <Base/Common/BIASpragmaEnd.hh>

namespace BIAS {

/**
 * @class FilterDialogPreviewWindow
 * @ingroup g_gui
 * @brief A preview window
 *
 * this window can show unsigned char and float images
 *
 * @author jfernand 08/09
 */

template <class StorageType>
class BIASGui_EXPORT FilterDialogPreviewWindow : public wxFrame
{
  public:
    FilterDialogPreviewWindow(const ImageBase& img,
                              wxWindow* parent,
                              const wxString& title,
                              wxWindowID id,
                              const wxString& name = wxT("FilterDialogPreviewWindow"),
                              const wxPoint& pos = wxDefaultPosition,
                              const wxSize& size = wxDefaultSize,
                              long style =  wxDEFAULT_FRAME_STYLE);

    ~FilterDialogPreviewWindow();

  private:
    wxBoxSizer* MainSizer;
    const ImageBase& OrigImg;
    void AdjustWindowDimension();
};

} // end namespace


#endif //  __FILTER_DIALOG_PREVIEW_WINDOW_HH
