#include "FitCircleFrame.hh"

using namespace std;
using namespace BIAS;


FitCircleFrame::
FitCircleFrame(const wxString& title, 
               const wxPoint& pos, 
               const wxSize& size,
               const Image<unsigned char> &img) 
  : wxDialog((wxFrame *)NULL, -1, title, pos, size,wxRESIZE_BORDER){
  xp = NULL;
  yp = NULL;
  rp = NULL;
  wxMenu *menuFile = new wxMenu;
  menuFile->Append( id_quit, wxT("E&xit") );
  wxMenuBar *menuBar = new wxMenuBar;
  menuBar->Append(menuFile, wxT("&File"));
  //  SetMenuBar(menuBar);
  //   CreateStatusBar(3);
  OrigImg_ = img;
  IC_ = new ImageCanvas(this,NULL, 0,-1,wxDefaultPosition,
                        wxSize(img.GetWidth(),img.GetHeight()));
  inkr = 1.0;
  Threshold_ = 0;
  thecolor[0] = 255; thecolor[1] = 0; thecolor[2] = 0;

  wxBoxSizer *vbox = new wxBoxSizer(wxVERTICAL);
  vbox->Add(IC_,1,  wxGROW |wxALL , 5);

  // use scrollbars if image is huge
  wxScreenDC screenDC;
  int screenWidth, screenHeight;
  screenDC.GetSize(&screenWidth, &screenHeight);
  if ((int)img.GetWidth() > screenWidth - 100 ||
      (int)img.GetHeight() > screenHeight - 100)
    {
      vbox->SetItemMinSize(IC_, 800, 600);
    }

  wxBoxSizer *hbox = new wxBoxSizer(wxHORIZONTAL);
  wxButton *button;
  button = new wxButton(this,id_left,wxT("Left"));
  hbox->Add(button);
  button = new wxButton(this,id_up,wxT("Up"));
  hbox->Add(button);
  button = new wxButton(this,id_down,wxT("Down"));
  hbox->Add(button);
  button = new wxButton(this,id_right,wxT("Right"));
  hbox->Add(button);
 
  hbox->Add(10, 5, 0,
            wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);
  wxStaticText* itemStaticText =
    new wxStaticText( this, wxID_STATIC, _("Max Camera Angle [°]"),
                      wxDefaultPosition, wxDefaultSize, 0 );
  spinCtrlAngle = new wxSpinCtrl( this, id_maxangle);
  spinCtrlAngle->SetRange(40,360);
  spinCtrlAngle->SetValue(180);

  hbox->Add(spinCtrlAngle);
  hbox->Add(itemStaticText);

  //add to vertical box
  vbox->Add(hbox);
  
  
  ////////////////////////////////////////
  // second row /////////////////////////
 
  hbox = new wxBoxSizer(wxHORIZONTAL);
  button = new wxButton(this,id_shrink,wxT("shrink"));
  hbox->Add(button);
  button = new wxButton(this,id_expand,wxT("Expand"));
  hbox->Add(button);
  button = new wxButton(this,id_dump,wxT("Dump"));
  hbox->Add(button);
  hbox->Add(95, 5, 0,
            wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);
 
  wxSpinCtrl *threshold = new wxSpinCtrl(this,id_threshold);
  threshold->SetRange(0,255);
  threshold->SetValue(0);
  hbox->Add(threshold);  
 
  wxStaticText* itemStaticText2 =
    new wxStaticText( this, wxID_STATIC, _("Image Threshold"),
                      wxDefaultPosition, wxDefaultSize, 0 );
  hbox->Add(itemStaticText2);

  vbox->Add(hbox);  
  //////////////////////////////
  wxSize sliderS(200,35);
  //intermediate row for labels
  hbox = new wxBoxSizer(wxHORIZONTAL);
  wxStaticText* itemStaticText3 =
    new wxStaticText( this, wxID_STATIC, _("Circle Size"),
                      wxDefaultPosition,sliderS , 0 );  
  hbox->Add(itemStaticText3);
  wxStaticText* itemStaticText4 =
    new wxStaticText( this, wxID_STATIC, _("Circle x Position"),
                      wxDefaultPosition, sliderS, 0 );  
  hbox->Add(itemStaticText4);
  wxStaticText* itemStaticText5 =
    new wxStaticText( this, wxID_STATIC, _("Circle y Position"),
                      wxDefaultPosition, sliderS, 0 );
 
  hbox->Add(itemStaticText5);
  vbox->Add(hbox);  
  ////////////////////////////////////////////
  //third row
  //add slider for expand and shrink
  hbox = new wxBoxSizer(wxHORIZONTAL);
 
  sizeSlider = 
    new wxSlider(this,id_sizeslider,100,0,1000,
                 wxDefaultPosition,sliderS,
                 wxSL_HORIZONTAL |  wxSL_LABELS| wxSL_BOTTOM);
  hbox->Add(sizeSlider);
  //////////////////
  xSlider = 
    new wxSlider(this,id_xslider,800,0,1600,
                 wxDefaultPosition,sliderS,
                 wxSL_HORIZONTAL |  wxSL_LABELS| wxSL_TOP);
  
  hbox->Add(xSlider);  
 
  ////////////////////
  ySlider = 
    new wxSlider(this,id_yslider,600,0,1200,
                 wxDefaultPosition,sliderS,
                 wxSL_HORIZONTAL |  wxSL_LABELS| wxSL_TOP);
 
  hbox->Add(ySlider);
   // ok button
  hbox->Add(100, 50, 0,
            wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);
  button = new wxButton(this,id_quit,wxT("OK"));
  hbox->Add(button,wxALIGN_RIGHT,10);

  vbox->Add(hbox);  
  ////////////////////////////////////////////
  vbox->SetSizeHints(this);
  SetMinSize(wxSize(800,600));
  SetSizer(vbox);
  SetAutoLayout(true);
  Fit();
  Show(TRUE);
}


void FitCircleFrame::
ListenToChange(float *x,float *y,float *r,float *maxangle){
  xp = x;
  yp = y;
  rp = r;
  maxanglep = maxangle;
}


void FitCircleFrame::
SetXYRA(float newx,float newy,float newr, float angle)
{
  x = newx;
  y = newy;
  r = newr;
  sizeSlider->SetValue((int)rint(r));
  xSlider->SetValue((int)rint(x));
  ySlider->SetValue((int)rint(y));
  maxangle = angle;
  UpdateImage();
}

void FitCircleFrame::
OnQuit(wxCommandEvent& WXUNUSED(event))
{
  Close(TRUE);
  Destroy();
}

void FitCircleFrame::
OnDump(wxCommandEvent& )
{
    unsigned int cutwidth,cutheight;
    if (DrawImg_.GetWidth() >640)
      cutwidth = cutheight = 640;
    else
      cutwidth = cutheight = 384;

    cout <<"CutOut of Size: "<<cutwidth<<" x "<<cutheight<<endl;
    cout <<"  at: "<<x-(cutwidth/2)<<" , "<<y-(cutwidth/2)<<endl;
	  wxString text;
	  text.Printf(wxT("Center:       %3.0f, %3.0f\n"
				  "Radius:       %3.0f\n"
				  "CutOut size:  %d, %d\n"
				  "Offset:       %d,%d"),x,y,r,
			cutwidth,cutheight,(int)(x-(cutwidth/2)),(int)(y-(cutwidth/2)));
	    wxMessageDialog dump(NULL,text);
    dump.ShowModal();

  }


void FitCircleFrame::
OnModifyCircle(wxCommandEvent& event)
{
  // find out which button it was and adapt x,y or r
  switch(event.GetId()) {
  case id_left:   x -= inkr; break;
  case id_right:  x += inkr; break;
  case id_up:     y -= inkr; break;
  case id_down:   y += inkr; break;
  case id_shrink: r -= inkr; break;
  case id_expand: r += inkr; break;
  case id_sizeslider: 
    r = (float)sizeSlider->GetValue();
    break;
  case id_xslider: 
    x = (float)xSlider->GetValue();
    break;
  case id_yslider: 
    y = (float)ySlider->GetValue();
    break;
  }

  UpdateImage();
}

void FitCircleFrame::
OnSlider(wxScrollEvent& event){
  switch(event.GetId()) {
  case id_sizeslider: 
    r = (float)sizeSlider->GetValue();
    break;
  case id_xslider: 
    x = (float)xSlider->GetValue();
    break;
  case id_yslider: 
    y = (float)ySlider->GetValue();
    break;
  }
  UpdateImage();
}

void  FitCircleFrame::
OnKey(wxKeyEvent &event)
{
  cout << "Key: "<<event.GetKeyCode()<<endl;
  switch(event.GetKeyCode()) {
  case WXK_LEFT:   x -= inkr; break;
  case WXK_RIGHT:  x += inkr; break;
  case WXK_UP:     y -= inkr; break;
  case WXK_DOWN:   y += inkr; break;
  case '-': r -= inkr; break;
  case '+': r += inkr; break;
  }

  UpdateImage();
}


void FitCircleFrame::
OnThreshold(wxSpinEvent & event)
{
  Threshold_=(unsigned char)event.GetPosition();
  UpdateImage();
}


void FitCircleFrame::
OnMaxAngle(wxSpinEvent & event)
{
  maxangle=(float)event.GetPosition();
  UpdateImage();
}


void FitCircleFrame::
UpdateImage()
  {
    //update listening pointers
    if(xp != NULL && yp != NULL && rp != NULL && maxanglep != NULL){
      *xp = x; *yp=y; *rp=r; *maxanglep=maxangle;
    }

    ImageConvert::ToRGB(OrigImg_,DrawImg_);
    if (Threshold_ >0)
      DrawImg_.AboveThresholdToValue(Threshold_,200);

    // store current scrollbar position
    int sx, sy;
    IC_->GetViewStart(&sx, &sy);

    ImageDraw<unsigned char>::CircleCenter(DrawImg_, int(x),int(y),int(r),
					   thecolor);
    IC_->Show(DrawImg_,"Foo");

    // restore scrollbar position
    IC_->Scroll(sx, sy);
  }


BEGIN_EVENT_TABLE(FitCircleFrame, wxDialog)
  EVT_MENU(id_quit, FitCircleFrame::OnQuit)
  EVT_BUTTON(id_left, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_quit, FitCircleFrame::OnQuit)
  EVT_BUTTON(id_up, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_down, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_right, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_shrink, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_expand, FitCircleFrame::OnModifyCircle)
  EVT_BUTTON(id_dump, FitCircleFrame::OnDump)
  EVT_SPINCTRL(id_threshold, FitCircleFrame::OnThreshold)
  EVT_SPINCTRL(id_maxangle, FitCircleFrame::OnMaxAngle)
  EVT_SCROLL(FitCircleFrame::OnSlider)
  EVT_CHAR(FitCircleFrame::OnKey)
END_EVENT_TABLE()

