#ifndef __HistoFrame_hh__
#define __HistoFrame_hh__

#include <bias_config.h>

#ifndef BIAS_HAVE_WXWIDGETS
#  error BIAS_HAVE_WXWIDGETS not defined but required by HistoFrame. Please enable BIAS_HAVE_WXWIDGETS in CMake configure step.
#endif
#include <Base/Common/BIASpragmaStart.hh>
#include <wx/wx.h>
#include <Base/Common/BIASpragmaEnd.hh>

namespace BIAS{

  class HistoImageCanvas;
  class ImageBase;

  /** @class HistoFrame
      @brief  It's a Frame used to have a Histogramm Canvas, which
      describes a histogramm of current image
      @author amattal 03/2007 */
  class BIASGui_EXPORT HistoFrame : public wxFrame
  {
    enum { MIA_HistoQuitButton };
  public:
    HistoFrame(wxWindow* parent, const wxString& title,
               wxPoint pos = wxPoint(10,10),
               wxSize size = wxSize(300, 250));
    ~HistoFrame();

    void NewImage(BIAS::ImageBase& im,
                  const wxString& name);

  protected:
    void Setup(wxSize size = wxSize(300, 250));
    void OnSize(wxSizeEvent& event);

    void OnQuit(wxCommandEvent & event);
    void OnClose(wxCloseEvent & event);

    wxString          ImageName_;
    wxString          Title_;
    wxButton         *QuitButton_;
    HistoImageCanvas *Window_;

    DECLARE_EVENT_TABLE()
  }; // class HistoFrame

} // namespace

#endif // __HistoFrame_hh__
