#ifndef __SettingsGL_hh__
#define __SettingsGL_hh__

// ----------------------------------------------------------
// @author Jan Woetzel (c)  10/2005
#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error Please recompile BIAS with USE_OPENGL to use this file. 
#endif // BIAS_HAVE_OPENGL

//#ifndef BIAS_HAVE_GLEW
//#  error Please recompile BIAS with USE_GLEW to use this file.
//#endif // BIAS_HAVE_GLEW

// must be first
#include "biasgl.h"


namespace BIAS {
	/** @class SettingsGL
	@ingroup g_gui
	@brief Application controlled OpenGl renderingsettings

	E.g. Vsync, Multisampling/Antialiasing, anisotropic filtering (planned), 
	@author Jan Woetzel
	*/
	class SettingsGL {
	public:

		/** query status of vsync/swap control interval=VSYNC JW */
		static int  GetVSyncInterval();

		/** set the vsync/swap control interval JW */
		static void SetVSyncInterval( const int & interval );		

	};
} // namespace BIAS
#endif
