#ifndef __VideoSource_Controller_PMD_HH__
#define __VideoSource_Controller_PMD_HH__

#include <bias_config.h>

#include <Base/Common/W32Compat.hh>
#include <VideoSource/VideoSource_Base.hh>

#ifdef BIAS_HAVE_PMD_PMDTec
#include <VideoSource/VideoSource_PMD.hh>
#endif

#include <Base/Image/ImageIO.hh>
#include <Base/Image/ImageConvert.hh>

#include <Image/Camera.hh>

#ifndef BIAS_HAVE_WXWIDGETS
#  error You need BIAS_HAVE_WXWIDGETS. Recompile BIAS with USE_WXWIDGETS.
#endif

#include <wx/wx.h>



namespace BIAS {

class BIASGui_EXPORT VideoSource_Controller_PMD : public ::wxFrame{
public:

  VideoSource_Controller_PMD(BIAS::VideoSource_PMD *cam, wxFrame *parent);

  ~VideoSource_Controller_PMD();

  void Initialize();

  void SetVideoSource(BIAS::VideoSource_PMD *cam);
// not yet implemented  void SetAmplitudeThresholdRange(unsigned int min,unsigned int max);
// not yet implemented  void SetModulationRange(unsigned int min,unsigned int max);
  void SetDistanceOffsetRange(unsigned int min,unsigned int max);
  void SetIntegrationTimeRange(unsigned int min,unsigned int max);
  void Update(); // trigger an update, useful for auto-mode
  

  wxBoxSizer        *vBox;
    
  enum {
    ID_HIDE,
// not yet implemented    ID_AMP,
// not yet implemented    ID_MOD,
    ID_DIST,
    ID_INT,
    ID_BUTTON_UPDATE,
    ID_TEXT
  };

private:

  void OnEscape(wxCommandEvent& event);
  void OnHide(wxCommandEvent& event);
  void OnClose(wxCloseEvent& event);
// not yet implemented  void OnAmplitude(wxScrollEvent& event);
// not yet implemented  void OnModulation(wxScrollEvent& event);
  void OnDistance(wxScrollEvent& event) ;
  void OnIntegration(wxScrollEvent& event) ;
// not yet implemented  void OnModFreq(wxScrollEvent& event) ;
  void OnUpdate(wxCommandEvent& event) ;

protected:
  
  BIAS::VideoSource_PMD *Cam_;
  
  wxSlider          *SliderAmplitude;
  wxSlider          *SliderSaturation;
  wxSlider          *SliderIntegration;
  wxSlider          *SliderDistanceOffset;
  wxSlider          *SliderModCoeff;
  wxBoxSizer        *sliderBox_ShGa;
  bool               sliderBox_ShGa_Visible;
 
  bool               vBoxVisible;

  wxButton          *showButton;
  wxButton          *update_Button;

// not yet implemented   unsigned int min_amplitudeThreshold_, max_amplitudeThreshold_;
   unsigned int min_integrationTime_, max_integrationTime_;
   unsigned int min_distanceOffset_, max_distanceOffset_;
// not yet implemented   int min_modulationFrequency_, max_modulationFrequency_;

  DECLARE_EVENT_TABLE()

private:
    };

}
#endif
