/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example ExampleCameraParam.cpp
   @class ExampleCameraParam
   @relates CameraParam 
   @brief Example for using old CameraParam object. CameraParam hold camera projection information, replaced
   by BIAS::Projection
   @ingroup g_examples
   @author MIP
*/

#include "Image/CameraParam.hh"
#include <iostream>
using namespace BIAS;
using namespace std;

int main (int argc, char* argv[])
{
  CameraParam cp;
 
#ifdef BIAS_HAVE_XML2
  if (argc<2) {
    cout <<"no file given, using some build-in data"<<endl;
    cp.SetData_OMNITECH_ORIFL_190_3();
  }
  else cp.ReadCameraData(argv[1]);
  
  cp.DebugOut();
  cp.WriteCameraData("CamDataTest.xml");
  cout <<"CamDataTest.xml created" << endl;
  //cp.DebugOut();

  CameraParam cp2;
  cp2.ReadCameraData("CamDataTest.xml");
  cp2.DebugOut();
  cp2.WriteCameraData("CamDataTestRewrite.xml");
  cout <<"CamDataTestRewrite.xml created" << endl;

#endif
  return 0;  
}
