/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __TrackerBaseWeighted1D_hh__
#define __TrackerBaseWeighted1D_hh__

#include <Matcher2D/TrackerBaseInterface.hh>
  
namespace BIAS {

  /** @class TrackerBaseWeighted1D
      @ingroup g_tracker
      @brief  
      @author woelk/kollmann 06/2006 */
  template <class StorageType>
  class BIASMatcher2D_EXPORT TrackerBaseWeighted1D
    : public TrackerBaseInterface<StorageType>
  {
  protected:
    Matrix<KLT_TYPE> _weight;
    
    virtual int Track_(Vector2<KLT_TYPE>& p1, Vector2<KLT_TYPE>& p2,
                       Vector2<KLT_TYPE>& result, KLT_TYPE& error, 
                       int &iter,
                       const Matrix2x2<KLT_TYPE>& AffinePred,
                       Matrix2x2<KLT_TYPE>& AffineResult);

    void CalcGaussianWeightMatrix_();

    using TrackerBaseInterface<StorageType>::_HalfWinSize;
    using TrackerBaseInterface<StorageType>::_MaxIterations;
    using TrackerBaseInterface<StorageType>::_MaxError;
    using TrackerBaseInterface<StorageType>::_MaxResiduumMAD;
    using TrackerBaseInterface<StorageType>::_RejectionType;
    using TrackerBaseInterface<StorageType>::_maxx1;
    using TrackerBaseInterface<StorageType>::_maxy1;
    using TrackerBaseInterface<StorageType>::_minx1;
    using TrackerBaseInterface<StorageType>::_miny1;
    using TrackerBaseInterface<StorageType>::_maxx2;
    using TrackerBaseInterface<StorageType>::_maxy2;
    using TrackerBaseInterface<StorageType>::_minx2;
    using TrackerBaseInterface<StorageType>::_miny2;
    using TrackerBaseInterface<StorageType>::_LastHalfWinSize;
    using TrackerBaseInterface<StorageType>::_WinSize;
    using TrackerBaseInterface<StorageType>::_gx;
    using TrackerBaseInterface<StorageType>::_gy;
    using TrackerBaseInterface<StorageType>::_bl1;
    using TrackerBaseInterface<StorageType>::_bl2;
    using TrackerBaseInterface<StorageType>::_gx1;
    using TrackerBaseInterface<StorageType>::_gy1;
    using TrackerBaseInterface<StorageType>::_gx2;
    using TrackerBaseInterface<StorageType>::_gy2;
    using TrackerBaseInterface<StorageType>::_gsx;
    using TrackerBaseInterface<StorageType>::_gsy;
    using TrackerBaseInterface<StorageType>::_gxx;
    using TrackerBaseInterface<StorageType>::_gxy;
    using TrackerBaseInterface<StorageType>::_gyy;
    using TrackerBaseInterface<StorageType>::_idet;
    using TrackerBaseInterface<StorageType>::BilinearRegion1_;
    using TrackerBaseInterface<StorageType>::BilinearRegion2_;
  }; 
}

#endif // __TrackerBaseWeighted1D_hh__
