/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/** @example ExampleNetSync.cpp
    @class ExampleNetSync
    @relates netsync
    @ingroup g_examples    
    @brief  this is an example for netsync
    @author MIP
*/

#include <sys/time.h>
#include <stdlib.h>
#include <sched.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include "../netsync.h"

#define MYSLEEP 20000


using namespace std;


int main (int argc, char* argv[]) {
  struct timeval tv;
  struct timezone tz;
  char name[256];
  long starttime, endtime;


  int i,n;
  long int res;


  char buffer[100];
  int bufflen;

  char **hostlist;

  n = gettimeofday (&tv, &tz);
  srand (tv.tv_usec);
  i=gethostname (name,80);
  if (i!=0) printf ("Failed to get host name.\n");

  if (argc <3) {
    printf("not enough hosts\n");
    exit(1);
  }
  /* hosts for the sync-tree */
  hostlist = (char**)malloc(sizeof(char *) * argc -2);
  for (i=1; i<argc; i++)
    hostlist[i-1] = argv[i];

//   netsync_init_withcontroller(argc-1 , hostlist);
  netsync_init(argc-1 , hostlist);

  for (i=0; i<5; i++) {
    n = gettimeofday (&tv, &tz);
    starttime=(tv.tv_sec%1000)*1000 + (tv.tv_usec/1000);
    /*      usleep (rand()/RAND_MAX*MYSLEEP/10+ MYSLEEP); */
    /*      if ((argc>1) && (i==50)) */
    /*        res=netsync_sync(netsync_exit); */
    /*      else */

    char magic[]="Hallo Welt";
    if (netsync_amiroot() ) {
      sprintf(buffer,magic);

    }
    bufflen = strlen(magic)+1;

    res=netsync_sync(netsync_finished, buffer, &bufflen);
    printf("Sync returned: %s\n",buffer);
    if (res==-1) {
      printf ("Netsync aborted \n");
      exit(0);
    }
    n = gettimeofday (&tv, &tz);
    endtime=(tv.tv_sec%1000)*1000 + (tv.tv_usec/1000);
    fprintf (stdout,"%03d %14s duration: %4i ms   %i ms\n", 
	     i,name,endtime-starttime,endtime);
    /*      fprintf (fd,"%03d %14s %4i %i\n",  */
    /*  	    i,name,endtime-starttime-(MYSLEEP/1000),endtime); */
  }

  netsync_cleanup();
  return 0;
}







