/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C) 2003-2009    (see file CONTACT for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __glfPassiveRenderTarget_hh__
#define __glfPassiveRenderTarget_hh__

#include <OpenGLFramework/Base/glfRenderTarget.hh>

namespace BIAS {
  
  /**  
   *  This class allows to use the currently set RenderTarget in the global 
   *   opengl state!
   *
   *  It is not the intention of the OpenGLFramework to work on a 
   *  global scope! Use this class with caution and seldom even if it is 
   *  convenient! 
   *  Your classes
   *  will develop difficult behavior and will not be transportable outside
   *  a well defined state context! Nevertheless it is usefull to use passive 
   *  components for the 
   *  integration of concepts from the OpenGLFramework into old software.
   *
   *  \author bartczak 02/2008
   **/
  class BIASOpenGLFramework_EXPORT glfPassiveRenderTarget : public glfRenderTarget 
  {
  public:
    virtual void Bind() const {}
  };

}

#endif
