/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C)  2008, 2009    (see file CONTACT for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __glfPBuffer_WGL_hh__
#define __glfPBuffer_WGL_hh__

#include "glfRenderingContext_WGL.hh"
#include <windows.h>

namespace BIAS {

  /**
   * WGL pbuffer rendering context.
   * \author 05/2007 jkollmann
   */
  class BIASOpenGLFramework_EXPORT glfPBuffer_WGL : public glfRenderingContext_WGL {
  public:
    glfPBuffer_WGL();
    ~glfPBuffer_WGL();

  protected:
    virtual HDC CreateDeviceContext(int width, int height, int pixelFormat);
    virtual void DestroyDeviceContext();
    virtual void GetSize(int& width, int& height);
    virtual int GetWglRenderTargetAttribute() const;
  
    HPBUFFERARB hglfPBuffer_;
  };
  
} // namespace BIAS

#endif // __glfPBuffer_WGL_hh__

