/*
 * DisparityInterpolator.hh
 *
 *  Created on: Jan 29, 2010
 *      Author: africk
 */

#ifndef __DISPARITY_INTERPOLATOR_HH__
#define __DISPARITY_INTERPOLATOR_HH__

#include <OpenGLFramework/Base/glfTexture2D.hh>
#include <OpenGLFramework/Base/glfBatch.hh>
#include <OpenGLFramework/Base/glfFramebufferObject.hh>
#include <OpenGLFramework/SpecializedBatches/PerPixelProcessingBase.hh>

#include <bias_config.h>

namespace BIAS {

class BIASOpenGLFramework_EXPORT DisparityInterpolator: public PerPixelProcessingBase {
public:

	enum INTERP_TYPE {
		LINEAR = 0, BG = 1
	};

	DisparityInterpolator();
	virtual ~DisparityInterpolator();

	void SetDisparityMap(glfTexture2D* dispMap);
	void SetInterpType(INTERP_TYPE interp_type) {
		interp_type_ = interp_type;
	}

	void Init(unsigned int width, unsigned int height);

	void Draw();

private:

	unsigned int width_, height_;

	INTERP_TYPE interp_type_;

	glfTexture2D* dispMapP_;

	std::string fragmentShaderCode_;

};
}

#endif /* __DISPARITY_INTERPOLATOR_HH__ */
