#ifndef __SOFT_MOTION_HH
#define __SOFT_MOTION_HH

namespace BIAS{

  class BIASPanTilt_EXPORT SoftMotion {
public:
	SoftMotion();
	~SoftMotion();

	void setLimits(int _min_pan, int _max_pan, int _min_pan_speed, int _max_pan_speed, int _min_tilt_speed, int _max_tilt_speed);

	void assert_pan(int &pan);
	void assert_tilt(int &tilt);

	int getPanSpeed(int start_pan, int end_pan, int cur_pan, int damp);
	int getTiltSpeed(int start_pan, int end_pan, int start_tilt, int end_tilt, int cur_pan, int cur_tilt, int damp);

private:
	int calcSpeed(int start_val, int end_val, int cur_val, int damp);
	bool tilt_active;
	int min_pan, max_pan, min_tilt, max_tilt, min_pan_speed, min_tilt_speed, max_pan_speed, max_tilt_speed;
	int min(int val1, int val2) {
		return (val1 < val2) ? val1 : val2;
	}
	int max(int val1, int val2) {
		return (val1 < val2) ? val2 : val1;
	}
};

typedef SoftMotion t_SoftMotion;
}
#endif
