//#include <Base/Common/LeakChecking.h>

#include <Base/Common/BIASpragma.hh>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstring>

using namespace std;

/**
   @file testLeak.cpp
   @brief compiling this source code should intentionally produce a memory Leak
   @ingroup g_tests
   @author jwoetzel
*/

/** create a leak with new  */
void MyLeak1new()
{
  char* ptr1=NULL;
  // Leak
  ptr1 = new char[512];
  strcpy(ptr1, "MLeak1new data. hello! 11111 ");
}


/** create a leak with malloc */
void MyLeak2malloc()
{
  char* ptr2=NULL;
  // Leak
  ptr2 = (char*)(malloc(4096*sizeof(char)));
  strcpy(ptr2, "MyLeak2malloc data. hello! 2222222 ");
}



/** not leaking new */
void NoLeak1()
{
  char* ptr1=NULL;
  const unsigned int sz=512;
  ptr1 = new char[sz];
  for (unsigned int i=0; i<sz; i++)
    {
      ptr1[i]=0;
    }
  // no leak
  delete [] ptr1;
}



/** not leaking malloc */
void NoLeak2()
{
  char* ptr2=NULL;
  const unsigned int sz=4096;
  ptr2 = (char*)(malloc(sz*sizeof(char)));
  for (unsigned int i=0; i<sz; i++)
    {
      ptr2[i]=0;
    }
  free(ptr2);
}





int main(int argc, char *argv[])
{
  cout<<"started ";
  if (argc>0) cout<<argv[0]<<" ";
  cout<<endl;

  // not leaking:
  NoLeak1();
  NoLeak2();

  // leaking:
  MyLeak1new();
  MyLeak2malloc();

  return 0;
}
