/*
   This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel


   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.

   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "BVWXApp.hh"
#include "BVWXMainFrame.hh"
#include "BVWXDnDTarget.hh"


IMPLEMENT_APP(BIAS::BVWXApp)

using namespace BIAS;

bool BVWXApp::OnInit()
{
  // utility: create a Redirection console for cout, cerr etc.
  ConsoleRedirectIO();

  BVWXMainFrame* frame = new BVWXMainFrame(wxT("BiasViewWX"),
                                                wxPoint(50, 50),
                                                FRAME_DEFAULT_SIZE);

  frame->Move(0,0); // move once on program start to upper left of screen

  // append file list given on command line
  {
    wxArrayString cmdFiles;
    for (int i = 1; i < argc; i++){
      cmdFiles.Add(wxString(argv[i]));
    }
    frame->LoadImages(cmdFiles);
  }

  // adapt Frame size on first loaded image
  frame->FitSizetIfTooSmall();

  // create drag and drop target
  BVWXDnDTarget* dndTarget = new BVWXDnDTarget(frame);

  frame->SetDropTarget(dndTarget);

  // show frame
  frame->Show(TRUE);
  SetTopWindow(frame);

  return TRUE;
}
