#include <Utils/DataPlot.hh>
#include <Base/Image/ImageIO.hh>
using namespace BIAS;
using namespace std;

int main(int argc,char *argv[])
{
  Image<unsigned char> plotarea(640,480,3);
  DataPlot Plot(plotarea);
  Plot.SetBGColour(ColourRGB<unsigned char>(10,10,10));
  Plot.Clear();

  Plot.SetXRange(0,100);
  Plot.SetYRange(-50,50);
  Plot.SetAutoRange(false,false);
  Plot.SetDrawingStyle(DataPlot::Lines);
  Plot.SetThickness(3);
  Plot.SetPenColour(ColourRGB<unsigned char>(255,0,0));
  Plot.DrawXAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(0,255,0));
  Plot.DrawYAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(255,255,0));
  for ( int i=0;i<100;i++)
    Plot.Plot(float(i),float(i-50));



  ImageIO::Save("ExampleDataPlot.ppm",plotarea,ImageIO::FF_ppm);




Plot.Clear();

  Plot.SetAutoRange(true,true);
  Plot.SetDrawingStyle(DataPlot::Points);
  Plot.SetThickness(3);
  Plot.SetPenColour(ColourRGB<unsigned char>(255,255,0));
  vector<float> data;
  for ( int i=0;i<100;i++) data.push_back(float(50-i));
  Plot.Plot(data);

  Plot.SetPenColour(ColourRGB<unsigned char>(255,0,0));
  Plot.DrawXAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(0,255,0));
  Plot.DrawYAxis();

  ImageIO::Save("ExampleDataPlot2.ppm",plotarea,ImageIO::FF_ppm);



  return 0;
}
