/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <iostream>
#include "../GenGroundTruth.hh"
#include "../../Base/Geometry/HomgPoint3D.hh"

using namespace std;
using namespace BIAS;

int main()
{
  vector<HomgPoint3D> ScenePoints1;
  vector<HomgPoint3D> ScenePoints2;
    // generates a default cube
  GenGroundTruth::GenerateRandomCube(ScenePoints1); 
  
  // generate 300 points in a 150x50x50 "crystal cube"
  GenGroundTruth::GenerateRandomCube(ScenePoints2, 300,
                                     0.0, 0.0, 0.0,
                                     1.0, 0.0, 0.0,
                                     1.0, 1.0, 0.0,
                                     0.0, 0.0, 1.0,
                                     150.0, 50.0, 50.0);

  unsigned int i;
  cout << "Points in scene 1:" << endl;
  for (i=0;i<ScenePoints1.size();i++)
    cout << ScenePoints1[i] << endl;

  cout << "\nPoints in scene 2:" << endl;
  for (i=0;i<ScenePoints2.size();i++)
    cout << ScenePoints2[i] << endl;
}
