#ifndef __GlewInitWrapper_hh__
#define __GlewInitWrapper_hh__

#include <Base/Common/Singleton.hh>

namespace BIAS {

  /**
   * @class GlewInitWrapper 
     @brief To call glewInit() at the right time and only once is not easy in
     complex applications. This wrapper helps to avoid calling it
     twice or more times.  At the eraliest possible place right after
     the gl-context is ready, just call:

     GlewInitWrapper::GetInstance()->Init();
     No need to protect it agains multiple calls, this is checked internally.
		 @ingroup g_openglframework	
		 @author MIP    
   */
  class BIASUtils_EXPORT GlewInitWrapper: public Singleton<GlewInitWrapper>
  {
    
  public:
    int Init();
    bool IsInitalised() {return IsInitialised_;} ;

    friend class BIAS::Singleton<GlewInitWrapper>;

  protected:

    GlewInitWrapper();

    bool IsInitialised_;
  }; //class


} //namespace


#endif
