#include "StringUtils.hh"

void BIAS::StringUtils::Explode(const std::string &str,
                                const std::string &seperator,
                                std::vector<std::string> &ret) {
  ret.clear();

  const int sepLen = seperator.length();

  // these indices mark beginning and end of the current token
  register int posL = 0;
  register int posR = str.find(seperator);

  // iterate over string
  while (posR > -1) {
    // skip empty strings (this can happen, when the seperator occures multiple
    // times successively)
    if (posL != posR) {
      ret.push_back(str.substr(posL, posR - posL));
    }

    // get indices for next iteration
    posL = posR + sepLen;
    posR = str.find(seperator, posL);
  }

  // if the string doesn't end with the seperator, push_back the last token
  if (posR == -1 && (unsigned int)posL < str.length()) {
    ret.push_back(str.substr(posL, str.length() - posL));
  }
}


void BIAS::StringUtils::Trim(const std::string &str,
                             std::string &ret,
                             const std::string &charsToTrim) {
  const int left  = str.find_first_not_of(charsToTrim);
  const int right = str.find_last_not_of(charsToTrim);

  if (left != -1 && right != -1) {
    ret = str.substr(left, right - left + 1);
  }
  else { // string only consists of charsToTrim characters or is empty
    ret = "";
  }
}