/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @file TestDShowVideo.cpp
   @brief Test Windows DirectShow Video Source 
   @relates VideoSource_DSHOW
   @ingroup g_tests
   @author MIP
*/

#include <iostream>
#include <vector>
#include <Image/Camera.hh>
#include <VideoSource/DShowVideo.hh>
#include <VideoSource/SampleGrabberCallback.hh>

using namespace std;
using namespace BIAS;

class SGCB : public SampleGrabberCallback
{
  STDMETHODIMP SampleCB(double SampleTime, IMediaSample *pSample)
  {
    cout << "SampleCB called\n";
    cout << "SampleTime: " << SampleTime << endl;
    cout << "pointer to sample: " << pSample << endl;
    cout << endl;
    return 0;
  }
};

int main()
{
  Camera<unsigned char> img;
  SGCB sgcb;

  DShowVideo vid(&sgcb);
  if (!vid.Open("C:/Dokumente und Einstellungen/buildmaster/Desktop/test.avi"))
  {
    cout << "Error opening the file!" << endl;
    return 1;
  }

  unsigned int w, h, c;
  vid.GetImageSize(w, h, c);
  cout << "width, height, channel count: " << w << ", " << h << ", " << c << endl;

  for (int i = 0; i < 10; i++)
    vid.PlaySingleFrame();

  vid.Close();
}
