/*
 * VideoSource_SonyX300.hh
 *
 *  Created on: Dec 8, 2009
 *      Author: africk
 */

#ifndef __VIDEOSOURCE_CENTAURUS_HH__
#define __VIDEOSOURCE_CENTAURUS_HH__

#include <VideoSource/VideoSource_Base.hh>
#include <Image/Camera.hh>
#include <bias_config.h>


//#define SV_FIFO_FLAG_NO_LIVE

namespace BIAS {

#include <dvs_setup.h>
#include <dvs_clib.h>
#include <dvs_fifo.h>

/**
  \class VideoSource_Centaurus
  \ingroup g_videosource
  \author africk
  \brief VideoSource for Centaurus boards and Sony HD cameras 
 */
class BIASVideoSource_EXPORT VideoSource_Centaurus: public VideoSource {

public:
	VideoSource_Centaurus();
	virtual ~VideoSource_Centaurus();

	virtual int OpenDevice();
	int OpenDevice(char * setup, int openprogram, int opentype, int timeout,
			int spare);

	virtual int CloseDevice();

	virtual int GrabSingle(BIAS::Camera<unsigned char> &image);

	/*
	 * SV_MODE_COLOR_YUV422_YUYV
	 * SV_MODE_SMPTE274_25sF, SV_MODE_SMPTE274_30sF
	 * SV_MODE_STORAGE_FRAME
	 */
	int SetVideoMode(int mode = (SV_MODE_COLOR_YUV422_YUYV
			| SV_MODE_SMPTE274_25sF | SV_MODE_STORAGE_FRAME));

	int InitFiFo();

	int InitImage(BIAS::ImageBase &Image);

	static char setup;
private:

	sv_handle* cam_handleP_;
	sv_fifo* inputFifoP_;
};
}

#endif /* __VIDEOSOURCE_CENTAURUS_HH__ */
