#ifndef __BIASVIDEOSOURCE_DV2_HH__
#define __BIASVIDEOSOURCE_DV2_HH__

#include "VideoSource_Base.hh"
#include <sys/time.h>
#include "/usr/src/linux-2.6.16.13-4/drivers/ieee1394/dv1394.h"



namespace BIAS{
/** 
	\class VideoSource_DV2
	\ingroup g_videosource
	\author evers
	\brief This class extends VideoSource for the use of IEEE1394-connected DV-camcorders.
	The low-level driver in DV2 is dv1394.o using DMA transfers.
	Create device: /dev/dv1394 171 32+i
*/
  class VideoSource_DV2 : public VideoSource{
  
 
  public: 
    VideoSource_DV2();
    ~VideoSource_DV2();

    int OpenDevice();
    int CloseDevice();

    int OpenDevice(const std::string &device);

    int UseChannel(int channel);
  
    int GrabSingle(BIAS::Camera <unsigned char>  &image);
  
    int PreGrab();
  
    int PostGrab();
  


  protected:
    int DV1394FD_;
  
    struct dv1394_init InitData_;
    struct dv1394_status Status_;
  
    enum pal_or_ntsc Format_;
    unsigned int FrameSize_;
  
    unsigned char *Buffer_;
    unsigned int BufferSize_;
  
  
  };

} // namespace MIP
#endif
