#ifndef __BIASVIDEOSOURCE_UEYE_HH__
#define __BIASVIDEOSOURCE_UEYE_HH__

#include <bias_config.h>


#ifdef WIN32
#include <windows.h>
#endif

#include <Image/Camera.hh>

#include <stdio.h>
#include <VideoSource/VideoSource_Base.hh>
#include "ueyeclass.hh"

namespace BIAS{

  /** 
      \class VideoSource_uEye
      \ingroup g_videosource
      \author ischiller
      \brief This class extends VideoSource for the use of IDS UEYE devices
  */
  class BIASVideoSource_EXPORT VideoSource_uEye : public VideoSource{
  
 
  public: 
    VideoSource_uEye();

    ~VideoSource_uEye();

    int OpenDevice();
    int CloseDevice();

    int GrabSingle(BIAS::Camera <unsigned char>  &image);
    int InitImage(BIAS::ImageBase &Image);
  
    int PreGrab();
    int PostGrab();

 
    int SetShutter(float exptime);
    int SetGain(float g);
    int SetPixelClock(int dClock);
  
    int SetEdgeEnhancement(int mode);
    float GetShutter();
    float GetGain();
    void SetFPS(float fps);

    void SetSize (int w, int h, int bytesperpixel=1);

    int SetLeftTop(unsigned int left, unsigned int top);

  protected:
    int               OpenCamera_();
    bool              m_bIsInited;

    int               m_dColorMode;
    int               m_dBitsPerPixel;
    int               m_dMemID;

    HIDS              m_CameraHandle;
    CuEye             m_ueye;
 
    unsigned int      m_dSrcWidth;
    unsigned int      m_dSrcHeight;
    unsigned int      m_dSrcDepth;

    int               m_dLeftPos;
    int               m_dTopPos;

    int               m_dPixelClock;
    
    char*             m_pImageBuffer;
    char*             m_pSwapBuffer;
    unsigned int		  m_dWidth;
    unsigned int		  m_dHeight;
    unsigned int		  m_dDepth;
    double            m_fGain;
    double            m_fShutter;
  
  }; //end class
}//end namespace bias
#endif
